//include libraries needed
#include <Ultrasonic.h>
#include <Stepper.h>

const int stepsPerRevolution = 2048;
//sequence of pin connections: in1, in3, in2, in4
Stepper realStepper = Stepper(stepsPerRevolution,7,12,8,13); //stepper motor for the real cash
// Define connection pins:
Ultrasonic ultrasonic(4, 5);

#define pirPin 2 //PIR sensor pin
#define ledPin 13
#define fakemotorpin 3 //connects to a transistor, which will control the speed of the DC motor
#define fakemotorspeed 200 
#define realmotorspeed 255
// Create variables:
int distance;
int realmotorpin1;
int realmotorpin2; //value of these two pins will change in different "if" conditions, which will activite different set of transistors in the circuit, result in a change of electricity's direction, therefore changing the direction of DC motor
int motionval = 0;
bool motionState = false; // We start with no motion detected.
bool cashstate = false;// initial cash state is inside

void setup() {
  // Configure the pins as input or output:
  pinMode(ledPin, OUTPUT);
  pinMode(pirPin, INPUT);
  pinMode(fakemotorpin, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(6, OUTPUT);
  realStepper.setSpeed(10);
  // Begin serial communication at a baud rate of 9600:
  Serial.begin(9600);
  Serial.println ("hello");
}

void loop() {
  //print the distance detected by the ultrasonic sensor
  distance = ultrasonic.read();
  Serial.print("Distance in CM: ");
  Serial.println(distance);
  // Read out the pirPin and store as val:
  motionval = digitalRead(pirPin);

  // If motion is detected (pirPin = HIGH), do the following:
  if (motionval == HIGH) {
    digitalWrite(ledPin, HIGH); // Turn on the on-board LED.
    realmotorpin1 = 6;
    realmotorpin2 = 9;
    // Change the motion state to true (motion detected):
    if (motionState == false) {
      Serial.println("Motion detected!");
      motionState = true;
      //Power the dc motor to suck the mony back when there's a change in motion state
     analogWrite(realmotorpin1, realmotorspeed);
     analogWrite(realmotorpin2, realmotorspeed); 
     delay (500); 
     //stop the motors when the action is done
     analogWrite(realmotorpin1, 0);
     analogWrite(realmotorpin2, 0); 
    }
    
    //Power the DC motor and stepper motor to throw fake money out when there's a change in motion state and cash state
    if (cashstate == true){
    analogWrite(fakemotorpin, fakemotorspeed);
    realStepper.step(stepsPerRevolution*3);
    delay (300);
    //stop all motors when the action is done
    analogWrite(fakemotorpin, 0);
    //some buffer time here
    delay (5000);
    //change the cash state
    cashstate = false;
    Serial.println("Cash is inside and fake money is out!");
    }
     
     
    
  
  }

  // If no motion is detected (pirPin = LOW), do the following:
  else {
    digitalWrite(ledPin, LOW); // Turn off the on-board LED.

    // Change the motion state to false (no motion):
    if (motionState == true) {
      Serial.println("Motion ended!");
      motionState = false;  
    }
     if (distance > 75) {
    //power the stepper motor to bring out the real money again when there's no motion, and no one is nearby
    realmotorpin1 = 10;
    realmotorpin2 = 11;
    analogWrite(realmotorpin1, realmotorspeed);
    analogWrite(realmotorpin2, realmotorspeed); 
    analogWrite(realmotorpin1, 0);
    analogWrite(realmotorpin2, 0); 
    //stop all motors when the action is done
    delay (100);
    //change the cash state
    if (cashstate == false)  {
      Serial.println("Cash is outside!");
      cashstate = true;
    }
      }
     
   
  }
}
